# Sid Meier's Civilization 4
# Copyright Firaxis Games 2007
# TechByConquestEvents
# Tech By Conquest Mod By Orion Veteran
# Modular python project to eliminate or reduce merging tasks

from CvPythonExtensions import *
import BugUtil
import BugCore
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser


# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
PyCity = PyHelpers.PyCity
PyGame = PyHelpers.PyGame


class TechByConquestEvents:
	def __init__(self, eventMgr):
# ###############################################################################
#		Important!!!!															#
#		Each function added from CvEventManager.py must be initialized here 	#
# ###############################################################################
		self.__LOG_CITYLOST = 0
		self.__LOG_TECH = 0		
		self.eventMgr = eventMgr
				
		eventMgr.addEventHandler("cityAcquired", self.onCityAcquired)
		
				
	def onCityAcquired(self, argsList):
		'City Acquired'
		iPreviousOwner,iNewOwner,pCity,bConquest,bTrade = argsList
# Tech By Conquest Mod
		# The Loser
		pPlayer1 = gc.getPlayer(iPreviousOwner)
		pTeam1 = gc.getTeam(pPlayer1.getTeam())
		# The Winner
		pPlayer2 = gc.getPlayer(iNewOwner)
		pTeam2 = gc.getTeam(pPlayer2.getTeam())
		FoundTransferTech = False		
		
		if bConquest:
			if not pPlayer1.isNone() and not pPlayer1.isBarbarian():
			
				for iTech in range(gc.getNumTechInfos()):
					# Does Player1 have a Tech that Player2 does not have?
					if pTeam1.isHasTech(iTech):
						if not pTeam2.isHasTech(iTech):
							iTechToTransfer = iTech
							FoundTransferTech = True
							break
							
				if FoundTransferTech:
					TechDescription = PyInfo.TechnologyInfo(iTech).getDescription()
					CyInterface().addImmediateMessage("Your scientists have discovered the knowledge of " + str(TechDescription), "")
					pTeam2.setHasTech(iTech,True,iNewOwner,False,False)
					
					# Show tech splash 
					if (iNewOwner > -1 and not CyInterface().noTechSplash()):
						if (gc.getGame().isFinalInitialized() and not gc.getGame().GetWorldBuilderMode()):
							if ((not gc.getGame().isNetworkMultiPlayer()) and (iNewOwner == gc.getGame().getActivePlayer())):
								popupInfo = CyPopupInfo()
								popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
								popupInfo.setData1(iTech)
								popupInfo.setText(u"showTechSplash")
								popupInfo.addPopup(iNewOwner)
					
				else:
					CyInterface().addImmediateMessage("The vanquished have no useful scientific knowledge.", "")
# End Tech By Conquest Mod

		CvUtil.pyPrint('City Acquired Event: %s' %(pCity.getName()))
		
		
		
	